require "defines"
require "scripts/conf_artillery"
require "scripts/artillery"

remote.addinterface("supremewarfare", {version= function()return "1.0.3"end})

local loaded

function reduceCooldown()
	if glob.listArty ~= nil then
		for k,v in pairs(glob.listArty) do
			if v[1].valid and v[2].valid then
				v[3]=v[3]-1
				if v[3] <=0 then
					processArty(v)
				end
			else
				if v[1].valid then
					v[1].destroy()
				end
				if v[2].valid then
					v[2].destroy()
				end
				table.remove(glob.listArty, k)
				if #glob.listArty == 0 then
					glob.listArty = nil
				end
			end
		end
	end
end

function ticker()
	if glob.listArty ~= nil then
		if glob.sbticks == 0 or glob.sbticks == nil then
			glob.sbticks = 60
			reduceCooldown()
		else
			glob.sbticks = glob.sbticks - 1
		end
	else
		game.onevent(defines.events.ontick, nil)
	end
end

game.onload(function()
	if not loaded then
		loaded = true
		if glob.listArty ~= nil then
			game.onevent(defines.events.ontick, ticker)
		end
	end
end)

game.oninit(function()
	loaded = true
	
	if glob.listArty ~= nil then
		game.onevent(defines.events.ontick, ticker)
	end
end)

function isArty(name)
if name =="sb-artillery-mk1" or name =="sb-artillery-mk2" or name =="sb-artillery-mk3" or name =="sb-rocketlauncher-mk3" or name =="sb-artillery-mk4" then
	return true
else
	return false
end
end
function isTarget(name)
if name == "sb-smoke-cloud" then
	return true
else
	return false
end
end

function builtEntity(event)

	local newArty
	local newArtyI
	local artyName
	
	if isArty(event.createdentity.name) then
		artyName=event.createdentity.name
	end
	
	if artyName ~= nil then
		newArty = game.createentity({name = artyName, position = event.createdentity.position, direction = event.createdentity.direction, force = game.forces.player})
		newArtyI = game.createentity({name = artyName.."i", position = event.createdentity.position, direction = event.createdentity.direction, force = game.forces.player})
		newArtyI.health = event.createdentity.health
		newArty.health = 0
		newArty.destructible = false
		event.createdentity.destroy()
		newArty.operable = false
		newArtyI.operable = true
		if glob.listArty == nil then
			glob.listArty = {}
			game.onevent(defines.events.ontick, ticker)
		end
		table.insert(glob.listArty, {newArty,newArtyI,0})
	end
end
--[[
function destroyArty(event)
	if event.entity.name == "sb-artillery-mk1i" or event.entity.name =="sb-artillery-mk2i" or event.entity.name =="sb-artillery-mk3i" or event.entity.name =="sb-artillery-mk4i" then
		for k,v in pairs(glob.listArty) do
			if v[1].valid ==false or v[2].valid == false then
				if v[1].valid then
					v[1].destroy()
				end
				if v[2].valid then
					v[2].destroy()
				end
				table.remove(glob.listArty, k)
				if #glob.listArty == 0 then
					glob.listArty = nil
				end
			end
		end
	end
end
]]
function addTarget(event)
	if isTarget(event.entity.name) then
		if glob.listTarget == nil then
			glob.listTarget = {}
		end
		table.insert(glob.listTarget, event.entity)
	end
end
game.onevent(defines.events.onbuiltentity, builtEntity)
game.onevent(defines.events.onrobotbuiltentity, builtEntity)
game.onevent(defines.events.ontriggercreatedentity, addTarget)
--game.onevent(defines.events.onpreplayermineditem, destroyArty)